﻿package  
{
	import com.flashdynamix.motion.TweensyZeroMinified;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.PixelSnapping;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.DropShadowFilter;

	/**
	 * ...
	 * @author yves trublin
	 */
	public class Photo extends Sprite
	{
		private var bitmapData:BitmapData;
		private var hauteurZonePhoto:Number;
		private var vitesseAffichagePhoto:Number;
		
		public function Photo(bmd:BitmapData, hzp:Number) 
		{
			bitmapData = bmd;
			hauteurZonePhoto = hzp;
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			var bmp:Bitmap = new Bitmap(bitmapData, PixelSnapping.AUTO, true);

			// ombre
			if (root["xml"].@["ombreSousPhoto"] == "true") {
				this.filters = [new DropShadowFilter(4, 45, root["xml"].@["couleurOmbre"], root["xml"].@["alphaOmbre"])];
			}
			
			// vitesse affichage
			vitesseAffichagePhoto = root["xml"].@["vitesseAffichagePhoto"];
			
			// placement photo
			x = - bmp.width * .5;
			y = (hauteurZonePhoto - bmp.height) * .5;

			addChild(bmp);
			
			alpha = 0;
		}
		
		public function montrerPhoto():void {
			TweensyZeroMinified.to(this.transform.colorTransform, { alphaMultiplier:1 }, vitesseAffichagePhoto, null, this);
		}
		
		public function cacherPhoto():void {
			TweensyZeroMinified.to(this.transform.colorTransform, { alphaMultiplier:0 }, vitesseAffichagePhoto, null, this, detruirePhoto);
		}
		
		private function detruirePhoto():void
		{
			this.filters.length = 0;
			removeChildAt(0);
			parent.removeChild(this);
		}
	}

}