﻿package  
{
	import com.flashdynamix.motion.TweensyZeroMinified;
	import flash.display.CapsStyle;
	import flash.display.JointStyle;
	import flash.display.LineScaleMode;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	/**
	 * ...
	 * @author yves trublin
	 */
	public class Bouton extends Sprite
	{
		private var hauteurBouton:Number;
		private var alphaBoutonOver:Number;
		private var alphaBoutonOut:Number;
		
		public function Bouton(h:Number) 
		{
			hauteurBouton = h;
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			tabEnabled = false;
			
			alphaBoutonOver = root["xml"].@["alphaBoutonOver"];
			alphaBoutonOut = root["xml"].@["alphaBoutonOut"];
			
			graphics.beginFill(root["xml"].@["couleurFondBouton"], root["xml"].@["alphaFondBouton"]);
			graphics.drawRect(0, 0, 30, hauteurBouton);
			graphics.endFill();

			graphics.lineStyle(1, root["xml"].@["couleurBordFleche"], root["xml"].@["alphaBordFleche"], false, LineScaleMode.NORMAL, CapsStyle.NONE, JointStyle.MITER, 3);
			graphics.moveTo(5, hauteurBouton * .5);
			graphics.beginFill(root["xml"].@["couleurFleche"], root["xml"].@["alphaFleche"]);
			graphics.lineTo(25, hauteurBouton * .5 - 10);
			graphics.lineTo(25, hauteurBouton * .5 + 10);
			graphics.endFill();
			
			alpha = alphaBoutonOut;
			buttonMode = true;
			
			addEventListener(MouseEvent.MOUSE_OVER, handleOverOut, false, 0, true);
			addEventListener(MouseEvent.MOUSE_OUT, handleOverOut, false, 0, true);
		}

		private function handleOverOut(e:MouseEvent):void 
		{
			var alpha:Number = alphaBoutonOut;
			if (e.type == MouseEvent.MOUSE_OVER) {
				alpha = alphaBoutonOver;
			}
			TweensyZeroMinified.to(this, { alpha:alpha, scaleY:1 });
		}
		public function racourcirBouton(r:Number):void
		{
			TweensyZeroMinified.to(this, { scaleY:r });
		}
	}
}